	device zxspectrum128

; temp pages:
Spr_page		equ #90
Vid_page		equ #60
Tile_page		equ #28
Tilegirl_spr_page	equ #98
Tiletext_spr_page	equ #a0
Tileded_spr_page	equ #a8
Tilelogo_spr_page	equ #b0

all_sprites	equ 10*8
transition_time	equ #48
part_time	equ 64*6*2	;4

; data pages:
snow_page	equ #20

mus_page	equ #25
mus_intro_page	equ #2e	
music_intro	equ #c100
music		equ #c000	
splash 		equ #c000
splash_page	equ #2b
girl_page	equ #21
girl 		equ #c000
font_page	equ #26
font		equ #c000
gift_page	equ #28
gift 		equ #c000
ded_page	equ #27
ded 		equ #c000
logo		equ #c000
logo_page	equ #2a
sfx_bank	equ #30


		org #8000
start
		di
		ld sp,#bfff

		call all_init
		call snow_init

		call intro_init

		call girl_loop
		call trans_girl

		call clear_tileset
;		ld bc,PAGE3
;		ld a,Tile_page
;		out (c),a
		xor a
		ld bc,T0YOFFSL
		out (c),a
		inc b
		out (c),a
		ld bc,T0GPAGE
		ld a,Tileded_spr_page
		out (c),a

		ld hl,#c000	; ded fill
		ld de,#3000
		ld bc,#101e	; 192:240
		call tile_filler

;		ld hl,#c05e	;+gift_scr_offset-#12	; gift fill
		ld hl,#c05e
		ld de,#2010
		ld bc,#111e	; 200:240
		call tile_filler

		ld bc,T1GPAGE
		ld a,Tiletext_spr_page
		out (c),a

main		call ded_part
		call trans_gift
		call gift_part

		call trans_ded
		ld a,#2a
		ld (txsin_pos+1),a
		call ded_part		; 7,8
		call trans_gift
;		ld a,#3b
;		ld (txsin_pos+1),a

		call gift_part		; 9, 10
		call trans_ded

		ld a,#45
		ld (txsin_pos+1),a
		call ded_part		; 11,12
		call trans_gift
;		xor a	;ld a,#3b
;		ld (txsin_pos+1),a
		call gift_part

		ld bc,PAGE3
		ld a,Tile_page
		out (c),a
		ld hl,#c000
		ld c,30
		xor a
logo_clear2	ld b,#10
logo_clear	ld (hl),a
		inc l
		ld (hl),a
		inc l
		djnz logo_clear
		inc h
		ld l,a
		dec c
		jr nz,logo_clear2
		call trans_ded

logo_view	xor a
		ld bc,T1XOFFSL
		out (c),a
		inc b
		out (c),a
		inc b
		out (c),a
		inc b
		out (c),a

		call clear_tileset
		ld bc,PALSEL
		ld a,#c0+#20+8
		out (c),a

		ld hl,#c98c
		ld de,#0000	; logo
		ld bc,#1c0c	; 224:96
		call tile_filler
		ld bc,T1GPAGE
		ld a,Tilelogo_spr_page
		out (c),a
		ld a,#0f
		ld (snows_type_and+1),a
		xor a
		ld (t1x_switch+1),a
logo_end	
		call wait_frame
		call snows_pos
		jr logo_end

trans_ded	call trans_init
		ld a,(txcur_pos)
		ld (trded_hide+1),a
		ld d,#48
trded_hide	ld a,#90
		dec a
		dec a
		or a
		jr c,trded_hide1
		ld (trded_hide+1),a
		ld bc,T0XOFFSL
		out (c),a
trded_hide1
		call wait_frame
		push de
		call snows_pos
		pop de
		dec d
		jr nz,trded_hide
		ret

trans_init
		call txy
trans_init2	ld (ded_hide+1),a
		ld a,#90
		ld (trded_hide+1),a

		ld bc,PAGE3
		ld a,Tile_page
		out (c),a
		ld (t1x_switch+1),a
		ld hl,#c080
		ld b,36
		jp clr_tile

txy		
txy2	
/*		ld bc,T0XOFFSL
		out (c),a
		ld bc,T0XOFFSH
		out (c),a
*/
		ld bc,T1YOFFSL
		out (c),a

		ret

gift_scr_offset	equ #50
trans_gift
		call trans_init

		ld d,#48
		ld a,(txcur_pos)
		ld (ded_hide+1),a
		add #90-8
		ld e,a

ded_hide	ld a,0
		inc a
		inc a
		cp e
		jr nc,ded_hide1
		ld (ded_hide+1),a
		ld bc,T0XOFFSL
		out (c),a
ded_hide1	call wait_frame
		push de
		call snows_pos
		pop de
		dec d
		jr nz,ded_hide
		ret

trans_girl
		xor a
		call trans_init

		ld hl,#c080
		ld de,#3000
		ld bc,#101e	; 192:240
		call tile_filler
		ld bc,T1GPAGE
		ld a,Tileded_spr_page
		out (c),a

		ld d,#48-9
girl_hide	ld a,#80
		dec a
		dec a
		ld (girl_hide+1),a
		ld bc,T1XOFFSL
		out (c),a
		add a,a
		ld bc,T0YOFFSL
		out (c),a
		push de
		call snows_pos
		pop de
		call wait_frame
		dec d
		jr nz,girl_hide
		ret


girl_loop
		ld hl,part_time-#48+21-3
		dec hl
		ld (girl_loop+1),hl
		ld a,l
		or h
		ret z

t0sin_pos	ld a,#2a-21
		inc a
		ld (t0sin_pos+1),a
		ld l,a
		ld h,high sin
		ld a,(hl)
		srl a

		add #80
		ld bc,T0YOFFSL
		out (c),a
		neg

		ld bc,T1YOFFSL
		out (c),a

scroll_wait0	ld hl,1
		dec hl
		ld a,h
		or l
		jr nz,scroll_wait_ex
		call scroll
		ld hl,64*6
scroll_wait_ex	ld (scroll_wait0+1),hl
		call snows_pos
		call wait_frame
		jr girl_loop




ded_part
		call txy
		xor a
		ld (t1x_switch+1),a
		ld (txsin_pos_ofset+1),a
		ld a,#3c	; inc a
		ld (lr_text),a
		jr gift_ded_loop

gift_part	
		xor a
		ld (t1x_switch+1),a
		ld (lr_text),a
		ld a,#84
		ld (txsin_pos_ofset+1),a


gift_ded_loop
		ld hl,part_time-transition_time
;		ld hl,64*3
		ld (main_loop+1),hl
		ld hl,1
		ld (ded_scroll_wait+1),hl
main_loop	ld hl,1
		dec hl
		ld (main_loop+1),hl
		ld a,l
		or h
		ret z

		call txsin_pos

ded_scroll_wait	ld hl,1
		dec hl
		ld a,h
		or l
		jr nz,scroll_wait_ex1
lr_text		nop
		call scroll
		ld hl,64*6
scroll_wait_ex1	ld (ded_scroll_wait+1),hl
		call snows_pos
		call wait_frame
		jr main_loop


txsin_pos	ld a,#2a
		inc a
		ld (txsin_pos+1),a
		ld l,a
		ld h,high sin
		ld a,(hl)
		srl a
		ld e,a
		srl a
txsin_pos_ofset
		add 0
		ld bc,T0XOFFSL
		out (c),a
		ld (txcur_pos),a
		ld a,e
		add #80
		neg
		ld bc,T1YOFFSL
		out (c),a
		ret

txcur_pos	db 0

clr_tile	ld c,l
		xor a
ct1		ld (hl),a
		inc l
		jr nz,$-2
		ld l,c
		inc h
		dec b
		jr nz,ct1
		ret

intro_init
		ld ix,font_db
		ld hl,#1000
		ld bc,#1006
fdb1		push bc
fdb2		ld (ix+0),l
		inc ix		
		ld (ix+0),h
		inc ix
		inc hl
		djnz fdb2
		ld de,#80-#10	; height 2 tiles
		add hl,de
		pop bc
		dec c
		jr nz,fdb1


		ld bc,PAGE3
		ld a,mus_intro_page
		out (c),a
		call music_intro

		ld hl,splash_copy
		call set_ports
		ld bc,PAGE1
		ld a,sfx_bank
		out (c),a
		ld bc,INTMASK
		ld a,3
		out (c),a
		ei
; ----
;		jr first_ex
; ----
		; splash wait
		ld bc,64*6*2-21
sp_wait		push bc
		call pal_lines
		call music_intro+5
		call wait_frame
		pop bc
		dec bc
		ld a,b
		or c
		jr nz,sp_wait
first_ex


		di
		xor a
		ld bc,VSINTL
		out (c),a
		inc b
		out (c),a
		ld hl,int
		ld (#beff),hl
		ld bc,INTMASK
		ld a,1
		out (c),a

		ei
		ld de,#0007
		ld bc,PALSEL
sp_wait2	out (c),d
		push de
		push bc
		call wait_frame
		call wait_frame
		call wait_frame
		pop bc
		pop de
		inc d
		dec e
		jr nz,sp_wait2

		ld hl,music+5
		ld (mus_play+1),hl
		ld a,mus_page
		ld (mus_play_page+1),a


		ld bc,PALSEL
		ld a,#80+#20+8
		out (c),a
		ld b,high PAGE3
		ld a,Vid_page
		out (c),a
		ld hl,#0
		ld (#c000),hl
		ld hl,clr_scr
		call set_ports

		ld hl,snow_pal	;redsnow_pal	;
		ld a,3
		call fade_pal

		call clear_tileset	
		ld bc,PAGE3
		ld a,Tile_page
		out (c),a

		ld hl,#c020
		ld de,#0000
		ld bc,#181e	; 192:240
		call tile_filler
		ld bc,VCONFIG
		ld a,VID_NOGFX+VID_16C+VID_320X240 ;%10000001	;VCONFIG VID_16C
		out (c),a
		ld bc,TMPAGE
		ld a,Tile_page
		out (c),a

		ld b,high T0GPAGE 
		ld a,Tilegirl_spr_page
		out (c),a
		ld b,high T1GPAGE 
		ld a,Tiletext_spr_page
		out (c),a

		ld b,high TSCONFIG
		ld a,TSU_SEN+ TSU_T0ZEN+TSU_T0EN+ TSU_T1ZEN+TSU_T1EN 
		out (c),a
		ld b,high BORDER
		ld a,#80
		out (c),a

		ld a,1
		ld b,high T0YOFFSH
		out (c),a
		ld a,#30
		ld bc,T0YOFFSL
		out (c),a
; ----
;		ret
; ----
		ld hl,64*6;-12*2
first_wait	push hl
		call snows_pos
		call wait_frame	
fwy1		ld a,1
		dec a
		and 3
		ld (fwy1+1),a
		jr nz,fwy3
fwy2		ld a,#30
		inc a
		ld (fwy2+1),a
		ld bc,T0YOFFSL
		out (c),a			
fwy3		pop hl
		dec hl
		ld a,l
		or h
		jr nz,first_wait
		ret




tile_scroll_adr	equ #d080

scroll
		ld hl,tile_scroll_adr	;+#80
		or a
		jr z,left_scroll
		ld hl,tile_scroll_adr+#20	;+#80
left_scroll	ld (view_txt_adr+1),hl
		ld a,l
		sub 2
		ld (txt_posy_init+1),a

		ld bc,PAGE3
		ld a,Tile_page
		out (c),a
view_char	ld hl,text
		ld a,(hl)
		cp #ff
		jr nz,vc2
		inc hl
		jr vc_ex

vc2		cp #fe
		jr nz,init_text
		ld hl,text
vc_ex		ld (view_char+1),hl
		ret

init_text	or a
		call z,txt_posy0
		inc hl
		ld (view_char+1),hl
		cp #61
		jr c,vc3
		sub #60
vc3		sub #20
		add a,a
		ld l,a
		ld h,high font_db
		ld e,(hl)
		inc hl
		ld d,(hl)
view_txt_adr	ld hl,0
		inc l
		inc l
		ld (view_txt_adr+1),hl
		ld bc,#40
		ld a,l
		dup 2
		ld (hl),e
		inc l
		ld (hl),d
		inc l
		ex de,hl
		add hl,bc
		ex de,hl
		ld l,a
		inc h
		edup 

		jr view_char

txt_posy0	push hl
		push af
txt_posy	ld a,(view_txt_adr+2)
		add 2
		ld h,a
txt_posy_init	ld l,#80-2
		ld (view_txt_adr+1),hl
		pop af
		pop hl
		ret

pal_lines	ld bc,faded_splash_db+#ff
		ld hl,0
pl_cnt		ld de,1
fsd		add hl,de
		ld a,h
		cpl
		and #e0
		rlca
		rlca
		rlca
		and #7
		or a
		jr nz,pl_fill
		ld (bc),a
		dec c
		jr nz,$-2
		jr pl_ex

pl_fill		ld (bc),a
		dec c
		jr nz,fsd
pl_ex		ld hl,(pl_cnt+1)
		ld de,6
		add hl,de
		ld (pl_cnt+1),hl
		ret


		; wait, , num_sprite, pal,  speed, Yadder, Y,Yhigh, X
snow_init	ld hl,spr_anim
		ld ix,spr1+1
		ld b,all_sprites
init_pos	push bc
		push hl
		call rnd
		ld c,a
		call rnd
		ld b,a
		pop hl
		ld a,c
		and 7
		ld (hl),a	; wait
		inc hl
		ld (hl),a	; cadr
		inc hl
		ld (hl),0	;num_sprite,
		inc hl
speed_cnt	ld a,10+1		; 56/8 = 7 snows on plane
		dec a
		ld (speed_cnt+1),a
		jr nz,init_pos1
		ld a,10
		ld (speed_cnt+1),a
		ld a,(init_pos1+1)
		add #20
		ld (init_pos1+1),a
		ld a,(init_pos2+1)
		sub #10
		ld (init_pos2+1),a

init_pos1	ld (hl),#10	;speed
		inc hl
init_pos2	ld (hl),#70	;pal (plane)	|| snow type
		inc hl

		ld (hl),0	; Yadder
		inc hl
		ld (hl),b	; Y
		inc hl
;		ld a,b
;		inc a
;		and 1
		ld a,1
		ld (hl),a	;Yhigh
		or (ix+0)
		ld (ix+0),a
		inc hl
		ld (hl),c	; X
		inc hl
		ld de,6
		add ix,de
		pop bc
		djnz init_pos
		ret

snows_pos	ld hl,spr_anim
		ld de,6
		ld ix,spr1
		ld b,all_sprites
		exx
		ld hl,sin
		exx
snows_pos1	
		ld a,(hl)	;wait
		inc a
snows_pos_and	and 7
		ld (hl),a
		inc hl
		or a
		jr z,snows_pos2
		inc hl		;num_sprite
		jr snows_pos3

snows_pos2	ld a,(hl)	; cadr
		inc a
		and 7
		ld (hl),a
		add a
		add a
		inc hl
		add (hl)
		ld (ix+4),a	

snows_pos3	inc hl
		ld c,(hl)	; speed
		inc hl
		ld a,(hl)
		ld (ix+5),a	;  pal
		inc hl
		ld a,(hl)	; Yadder
		add c
		ld (hl),a
		inc hl
		jr nc,snows_pos4
		ld a,(hl)	; Y++
		inc a
		ld (hl),a
		jr nz,snows_pos4
		inc hl
		ld a,(hl)
		xor 1
		ld (hl),a
		dec hl
		ld a,(ix+1)
		xor 1
		ld (ix+1),a

		; wait, , num_sprite, pal,  speed, Yadder, Y,Yhigh, X
;		db 4,4,0,0,1,1,1,0,1
snows_pos4	
		ld a,(hl)
		ld (ix+0),a
		inc hl
		inc hl
		inc (hl)
		ld a,(hl)
		exx
		ld l,a
		ld a,(hl)
		exx
		ld (ix+2),a	; X
		inc hl		
		add ix,de
		ld a,(snows_pos_and+1)
		xor 4
		ld (snows_pos_and+1),a
		djnz snows_pos1
		ret

		
lp_temp_sp	ds 16

int		di
		push af
		push hl
		push de
		push bc
frame_int	ld a,0
		inc a
		ld (frame_int+1),a
		ld hl,sprites
		call set_ports

main_posx2	ld hl,sinx-1
t1x_pos		ld a,0-20
		inc a
		cp 192
		jr nz,main_sinpos2
		xor a
		ld hl,sinx-1
main_sinpos2	inc hl
		ld (main_posx2+1),hl
		ld (t1x_pos+1),a
t1x_switch	ld a,0
		or a
		jr nz,t1x_ex

		ld a,(hl)
		ld bc,T1XOFFSL
		out (c),a		
		srl a
		ld bc,T1YOFFSL
		out (c),a		

t1x_ex
		ld a,0
		inc a
snows_type_and	and #1f
		ld (t1x_ex+1),a
		jr nz,t1x_ex1
		; wait, , num_sprite, pal,  speed, Yadder, Y,Yhigh, X
snows_type_cnt	ld hl,spr_anim+4
		ld bc,spr_anim+4+all_sprites*9
		ld a,(hl)
		and #f0
		ld e,a
		ld a,(hl)
		and 3
		inc a
		cp #3
		call z,rand_snows
		or e
		ld (hl),a
		ld de,9
		add hl,de
		ld (snows_type_cnt+1),hl
		or a
		sbc hl,bc
		jr nz,t1x_ex1
		ld hl,spr_anim+4
		ld (snows_type_cnt+1),hl
t1x_ex1		ld bc,PAGE3
mus_play_page	ld a,mus_intro_page
		out (c),a
mus_play	call music_intro+5

		pop bc
		pop de
		pop hl
		pop af
		ei
		ret

rand_snows	ld a,r
		xor l
		and 3
		cp 3
		jr z,rand_snows
		ld e,a
		sla e
		sla e
		sla e
		sla e
		ret

line_proc	di
		push af
		push hl
		push bc

linex_cnt	ld hl,faded_splash_db
		inc hl
		ld (linex_cnt+1),hl
		ld a,(hl)
		ld bc,PALSEL
		out (c),a
		call sfx_pos
		pop bc
		pop hl
		pop af

		ei
		ret

line_sfx_proc	di
		push af
		push hl
		push bc
		call sfx_pos
		pop bc
		pop hl
		pop af
		ei
		ret

sfx_frame	equ 320

sfx_pos		ld hl,#4000	; 15625 
		inc hl
		ld a,h
		cp #80
		jr nz,sp2
sfx_bank_pos	ld a,sfx_bank
		inc a
		and #0f
		or sfx_bank
		ld (sfx_bank_pos+1),a
		ld bc,PAGE1
		out (c),a
		ld hl,#4000
sp2		ld (sfx_pos+1),hl
		ld a,(hl)
		out (#fb),a
		ret


splash_int	di
		push af
		push hl
		push bc
		ld a,(frame_int+1)
		inc a
		ld (frame_int+1),a
		ld hl,line_sfx_proc
		ld (#befd),hl

		ld hl,30+24
		ld bc,VSINTL
		out (c),l
		ld bc,VSINTH
		out (c),h
		ld hl,im_blank_off
		ld (#beff),hl

		ld hl,faded_splash_db
		ld (linex_cnt+1),hl
		pop bc
		pop hl
		pop af
		ei
		ret




im_blank_off
		di
		push af
		push bc
		push hl

		ld hl,31+24+240
		ld bc,VSINTL
		out (c),l
		ld bc,VSINTH
		out (c),h
		ld hl,line_proc
		ld (#befd),hl
		ld hl,im_blank_ex
		ld (#beff),hl		
		pop hl
		pop bc
		pop af
		ei
		ret

im_blank_ex
		di
		push af
		push bc
		push de
		push hl
		xor a
		ld bc,VSINTL
		out (c),a
		ld bc,VSINTH
		out (c),a
		ld hl,line_sfx_proc
		ld (#befd),hl

		ld hl,splash_int
		ld (#beff),hl		

		pop hl
		pop de
		pop bc
		pop af
		ei
		ret



wait_frame	ld a,(frame_int+1)
		or a
		jr z,wait_frame
		dec a
		ld (frame_int+1),a
		ret


fade_pal	ld de,faded_pal
		ex de,hl
		ld (c_pal+1),hl
		ex de,hl
		ld bc,32
		ldir
		ld b,7
c_pal1		push bc
		push af
		ld hl,(c_pal+1)
		call fadeOUT
c_pal		ld hl,0
		ld de,32
		add hl,de
		ld (c_pal+1),hl
		ex de,hl
		ld hl,temp_pal
		ld bc,32
		ldir
		pop af
		pop bc
		djnz c_pal1
		ld hl,sn_pal
		jp set_ports


fadeOUT
fadeOUT_pal	ld de,temp_pal
		ld bc,32
		ldir
fadeout1	ld b,a
fadeout3	push bc
		ld hl,temp_pal
		ld b,#10
fadeout2	push bc
		xor a
		ld (greenH+1),a	; Green High
		ld (greenL+1),a ; Green Low
		ld (red+1),a
		ld (blue+1),a
		call fdin
greenL		ld a,0
blue		or 0
		ld (hl),a
		inc hl
red		ld a,0
greenH		or 0
		ld (hl),a
		inc hl
		pop bc
		djnz fadeout2
		pop bc
		djnz fadeout3
		ret

temp_pal	ds 32

fdin		inc hl
		ld a,(hl)	; 0RRrrrGG gggBBbbb
		dec hl
		push af
		and %01111100
		srl a
		srl a
		cp 24
		jr z,fd21
		inc a
fd21		sla a
		sla a
		ld (red+1),a; R

		pop af
		and %00000011	; GG
		ld c,a
		ld a,(hl)
		push af
		and %11100000	; ggg  	0RRrrrGG gggBBbbb
		sla a
		rl c
		sla a
		rl c
		sla a
		rl c
		ld a,c
		cp 24
		jr z,fd22
		inc a
fd22		ld c,0
		srl a
		rr c
		srl a
		rr c
		srl a
		rr c
		ld (greenH+1),a	; Green High
		ld a,c
		ld (greenL+1),a ; Green Low

		pop af
		and %00011111
		cp 24
		jr z,fd31
		inc a
fd31		ld (blue+1),a
		ret
/*
:          . .. /  .

:
D -      (#00, #40, #80  #C0   0,1,2  3, )
E -    ,
HL - Y-,
BC - X-.

:
A -  ,   ,
DE -    ,
CF -    : 0 - , 1 - .
*/

crd2pixaddr16c
	ld a,l
	and #3f
	or d
	ld d,a
	add hl,hl
	add hl,hl
	ld a,h
	add a,e
	srl b
	rr c
	ld e,c
	ret

	

umul16x16:
    ; in:
    ; bc = n1
    ; hl = n2
    ; de = 0x0000
    ; out:
    ; hl = result
           
loop16
        srl b
        rr c
        jr nc,skip16
        ex de,hl
        add hl,de
        ex de,hl
	add hl,hl
	jr loop16
skip16
	ld a,b
	or c
	jr nz,loop16
	ret




DE_Div_BC          ;1281-2x, x is at most 16
	ld a,16        ;7
	ld hl,0        ;10
	jr $+5         ;10
DivLoop
	add hl,bc    ;--
	dec a        ;64
	ret z        ;86

	sla e        ;128
	rl d         ;128
	adc hl,hl    ;240
	sbc hl,bc    ;240
	jr nc,DivLoop ;23|21
	inc e        ;--
	jr DivLoop+1


RoundHL_Div_C:
   xor	a
   ld	b, 16

_loop:
   add	hl, hl
   rla
   cp	c
   jr	c, $+4
   sub	c
   inc	l   
   djnz	_loop
;This part is the rounding
   add a,a
   cp	c
   ret	c
   inc hl
   ret

FPDiv:
   ; Divides AHL by CDE, returns result in AHL
   push hl
   ld l,a
   xor a
   ld h,a
   exx
   pop hl
   ld c,h
   ld h,l
   ld l,a
   ld b,24
FPDivLoop:
   add hl,hl
   rl c
   exx
   adc hl,hl
   rla
   sbc hl,de
   sbc a,c
   jr nc,FPDivNoRestore
   add hl,de
   adc a,c
   exx
   djnz FPDivLoop
   ld a,c
   ret
FPDivNoRestore:
   exx
   inc l
   djnz FPDivLoop
   ld a,c
   ret

		
rnd     	ld  de,0x82a7   ; xz -> yw
		ld  hl,0xfc2c  ; yw -> zt; 0xC0DE
		ld  (rnd+1),hl  ; x = y, z = w
		ld  a,l         ; w = w ^ ( w << 3 )
		add a,a
		add a,a
		add a,a
		xor l
		ld  l,a
		ld  a,d         ; t = x ^ (x << 1)
		add a,a
		xor d
		ld  h,a
		rra             ; t = t ^ (t >> 1) ^ w
		xor h
		xor l
		ld  h,e         ; y = z
		ld  l,a         ; w = t
		ld  (rnd+4),hl
		ret

all_init	xor a	
		ld bc,HSINT
		out (c),a
		inc b
		out (c),a
		inc b
		out (c),a
		ld e,7
		ld b,#40
		out (c),a
		inc b
		dec e
		jr nz,$-4
		call spr_off
		ld a,#be
		ld i,a
		ld hl,splash_int
		ld (#beff),hl
		ld hl,line_proc
		ld (#befd),hl
		im 2
/*
		ld de,sin
		ld bc,#403f 	;b:, :      b!!!
		call SINMAKE
*/
		ld bc,PAGE3
		ld a,mus_page
		out (c),a
		call music

		ld bc,SGPAGE
		ld a,Spr_page
		out (c),a

		ld bc,PAGE3
		ld a,Vid_page
		out (c),a
		ld hl,#ffff		;1111 - white
		ld (#c000),hl
		ld hl,init_ts
		call set_ports
		ld hl,snow_copy
		call set_ports

		ld hl,girl_copy
		call set_ports
		ld hl,font_copy
		call set_ports
		ld hl,gift_copy
		call set_ports
		ld hl,ded_copy
		call set_ports
		ld hl,logo_copy
		call set_ports
		ld hl,splash_pal
		ld a,4
		jp fade_pal


/*
		ld bc,PAGE3
		ld a,Tile0_spr_page
		out (c),a
		ld hl,#0		;1111 - white
		ld (#c000),hl
		ld hl,clear_gfx__tile
		call set_ports
*/

;		call clear_tileset	


/*
		ld bc,PAGE3
		ld a,Spr_page
		out (c),a
		ld hl,0
		ld (#e400),hl
		ld hl,spr_clear
		call set_ports
*/

;		ld hl,paltw
;		call set_ports
/*
;		call clear_tileset	
		ld bc,PAGE3
		ld a,Tile_page
		out (c),a

		ld hl,#c000
		ld de,#0000
		ld bc,#281e	; 320:240
		call tile_filler
*/
/*
		ld bc,TMPAGE
		ld a,Tile_page
		out (c),a
		ld b,high T0GPAGE 
		ld a,Tile0_spr_page
		out (c),a
*/

/*
		ld bc,T1GPAGE 
		ld a,Tile_robo_spr_page
;		ld a,Tile1_spr_page
		out (c),a
*/


;		ld bc,PALSEL
;		ld a,#08
;		out (c),a
/*
; robo
;		ld hl,#c0a0-4
		call clear_tileset
		ld hl,#c61e
		ld de,#0000
		ld bc,#1918	; 104x192
		call tile_filler
*/

; viola shadow
/*
		ld hl,#c080
		ld de,#c004
		ld bc,#281e
vs0		push bc
vs1		ld a,(hl)
		ld (de),a
		inc hl
		inc de
		ld a,(hl)
		or #10
		ld (de),a
		inc hl
		inc de
		djnz vs1
		inc h
		ld l,#80
		inc d
		ld e,#04
		pop bc
		dec c
		jr nz,vs0
*/

/*
		ld hl,#c000
		ld de,#2000
		ld bc,#281e	; 128x160
		call tile_filler
*/
/*
		ld hl,#c000+10
		ld de,#0006
		ld bc,#1e1e	; 128x160
		call tile_filler_90cc
		ret
*/
/*
		ld hl,#c028
		ld ix,#c04e
		ld de,#4000
		ld bc,#141e	; 128x160
		call tile_filler_backward
*/

tile_filler_backward
tfb1		push bc
tfb2		ld (hl),e
		dec hl
		ld (hl),d
		dec hl
		ld a,e
		add #14
		ld (ix+0),a
		dec ix
		ld (ix+0),d
		dec ix
		inc de
		djnz tfb2
		inc h
		ld l,#28
		inc ixh
		ld ixl,#5c
		ex de,hl
tfb4		ld bc,#40-#14
		add hl,bc
		ex de,hl
		pop bc
		dec c
		jr nz,tfb1
		ret



tile_filler_90cc
		ld a,h
		ld (tf90cc3+1),a
tf90cc1		push bc
tf90cc2		ld (hl),e
		inc l
		ld (hl),d
		dec l
		inc h
		inc de
		djnz tf90cc2
		ex de,hl
tf90cc4		ld bc,#40-#1e
		add hl,bc
		ex de,hl
		inc l
		inc l		
tf90cc3		ld h,0
		pop bc
		dec c
		jr nz,tf90cc1
		ret


tile_filler	ld a,l
		ld (rfil3+1),a
		ld a,#40
		sub b
		ld (rfil4+1),a
rfil1		push bc
rfil2		ld (hl),e
		inc l
		ld (hl),d
		inc l
		inc de
		djnz rfil2
		inc h
rfil3		ld l,0
		ex de,hl
rfil4		ld bc,0
		add hl,bc
		ex de,hl
		pop bc
		dec c
		jr nz,rfil1
		ret


clear_tileset	ld bc,PAGE3
	    	ld a,Tile_page
		out (c),a
clr_tileset_pal	ld hl,#0000
		ld (#c000),hl
		ld hl,tileset_clr
		jp set_ports


spr_off		ld bc, FMADDR
		ld a, FM_EN
		out (c), a      ; open FPGA arrays at #0000
		; clean SFILE

FM_SFILE        equ #0200
		ld hl,FM_SFILE
		xor a
spr_off_l1	ld (hl), a
		inc l
		jr nz,spr_off_l1
		inc h
spr_off_l2	ld (hl), a
		inc l
		jr nz,spr_off_l2
		out (c), a      ; close FPGA arrays at #0000
		ret



init_ts		db #00,VID_16C+VID_320X240 ;%10000001	;VCONFIG VID_16C
		db #01,Vid_page	;VPAGE
		db #20,6	; SYSCONFIG
		db #2b,%1111
		db #0f,#7f	; border
		db 6,0		; TSConfig
		db 7,8		; palsel

clr_scr		defb #1a,0	;
		defb #1b,0	;
		defb #1c,Vid_page	;
		defb #1d,0	;
		defb #1e,0	;
		defb #1f,Vid_page	;

		defb #28,#ff	;
		defb #26,#ff	;
		defb #27,%00000100

		db #ff


tileset_clr
		defb #1a,0	;
		defb #1b,0	;
		defb #1c,Tile_page	;
		defb #1d,0	;
		defb #1e,0	;
		defb #1f,Tile_page	;
		defb #28,#ff	;
		defb #26,#1f	;
		defb #27,%00000100
		db #ff

sn_pal		
		db #1a,low faded_pal
	        db #1b,high faded_pal
		db #1c,2
	        db #1d,0
	        db #1e,0
	        db #1f,0
	        db #26,#e0 
	        db #28,0
		db #27,#84
		db #ff

splash_copy
		db #1a,low splash
	        db #1b,high splash
		db #1c,splash_page
		db #1d,0
	        db #1e,0
	        db #1f,Vid_page ;viol_page ;
	        db #26,320/4-1
	        db #28,240-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

font_copy
		db #1a,low font
	        db #1b,high font
		db #1c,font_page
		db #1d,0
	        db #1e,0
	        db #1f,Tiletext_spr_page ;viol_page ;
	        db #26,128/4-1
	        db #28,96-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

girl_copy
		db #1a,low girl
	        db #1b,high girl
		db #1c,girl_page
		db #1d,0
	        db #1e,0
	        db #1f,Tilegirl_spr_page ;viol_page ;
	        db #26,192/4-1
	        db #28,240-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

ded_copy
		db #1a,low ded
	        db #1b,high ded
		db #1c,ded_page
		db #1d,0
	        db #1e,0
	        db #1f,Tileded_spr_page ;viol_page ;
	        db #26,128/4-1
	        db #28,240-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

gift_copy
		db #1a,low gift
	        db #1b,high gift
		db #1c,gift_page
		db #1d,#40
	        db #1e,0
	        db #1f,Tileded_spr_page ;viol_page ;
	        db #26,200/4-1
	        db #28,240-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

logo_copy
		db #1a,low logo
	        db #1b,high logo
		db #1c,logo_page
		db #1d,0
	        db #1e,0
	        db #1f,Tilelogo_spr_page ;viol_page ;
	        db #26,224/4-1
	        db #28,96-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

snow_copy
		db #1a,0
	        db #1b,0
		db #1c,snow_page
		db #1d,0
	        db #1e,0
	        db #1f,Spr_page ;Vid_page ;viol_page ;
	        db #26,256/4-1
	        db #28,96-1
		db #27,DMA_RAM + DMA_DALGN
		db #ff

sprites
		db #1a,low spr_db
	        db #1b,high spr_db
		db #1c,2
	        db #1d,0
	        db #1e,2
	        db #1f,0
	        db #26,(all_sprites+2)/2*6
	        db #28,0
		db #27,DMA_RAM_SFILE
		db #ff
/*
back_pic_copy	
		db #1a,low lamp_pic
	        db #1b,high lamp_pic
		db #1c,lamp_pic_page
	        db #1d,0
	        db #1e,0
	        db #1f,Tile0_spr_page
	        db #26,256/4-1
	        db #28,#ff
		db #27,DMA_RAM + DMA_DALGN
		db #ff
backlamp_pal		; palitra back lamps
		defb    #1a,low back_pal
	        defb    #1b,high back_pal
		defb    #1c,lamp_pic_page+2
	        defb    #1d,#20
	        defb    #1e,0
	        defb    #1f,0
	        defb    #26,16
	        defb    #28,0
		db 	#27,#84
		db #ff
*/


/*
rasp_pal		; palitra back lamps
		defb    #1a,low raspberry_pal
	        defb    #1b,high raspberry_pal
		defb    #1c,rasp_pic_page
	        defb    #1d,#40
	        defb    #1e,0
	        defb    #1f,0
	        defb    #26,16
	        defb    #28,0
		db 	#27,#84
		db #ff
*/


set_ports_no_wait
		ld c,#AF
.m2		ld b,(hl) 
		inc hl
		inc b
		ret z
		outi
		jr .m2

set_ports	ld c,#AF
.m1		ld b,(hl) 
		inc hl
		inc b
		jr z,dma_stats
		outi
		jr .m1

dma_stats	ld b,high DMASTATUS
		in a,(c)
		AND #80
		jr nz,$-4
		ret

Galois16	ld   hl, #FFFF      ; 10
SeedValue	EQU   $-2
		add  hl, hl         ; 11
		sbc  a         ; 4
		and  #EB         ; 7 instead of #EB one can use #AF
		ld   c, a         ; 4
		xor  l         ; 4
		ld   l, a         ; 4
		ld   a,c         ; 4
		xor  h         ; 4
		ld   h,a         ; 4
		ld   (SeedValue), hl      ; 16
		and   %10101010
		add   l         ; +7+4 => +11t
		ret 

SINMAKE INC     C
        LD      HL,SIN_DAT
        PUSH    BC
        LD      B,E
LP_SMK1 PUSH    HL
        LD      H,(HL)
        LD      L,B
        LD      A,#08
LP_SMK2 ADD     HL,HL
        JR      NC,$+3
        ADD     HL,BC
        DEC     A
        JR      NZ,LP_SMK2
        LD      A,H
        LD      (DE),A
        POP     HL
        INC     HL
        INC     E
        BIT     6,E
        JR      Z,LP_SMK1
        LD      H,D
        LD      L,E
        DEC     L
        LD      A,(HL)
        LD      (DE),A
        INC     E
LP_SMK3 LD      A,(HL)
        LD      (DE),A
        INC     E
        DEC     L
        JR      NZ,LP_SMK3
LP_SMK4 LD      A,(HL)
        NEG
        LD      (DE),A
        INC     L
        INC     E
        JR      NZ,LP_SMK4
        POP     BC
LP_SMK5 LD      A,(DE)
        ADD     A,B
        LD      (DE),A
        INC     E
        JR      NZ,LP_SMK5
	di
        RET

SIN_DAT
		DB #00,#06,#0D,#13,#19,#1F,#25,#2C
		DB #32,#38,#3E,#44,#4A,#50,#56,#5C
		DB #62,#67,#6D,#73,#78,#7E,#83,#88
		DB #8E,#93,#98,#9D,#A2,#A7,#AB,#B0
		DB #B4,#B9,#BD,#C1,#C5,#C9,#CD,#D0
		DB #D4,#D7,#DB,#DE,#E1,#E4,#E7,#E9
		DB #EC,#EE,#F0,#F2,#F4,#F6,#F7,#F9
		DB #FA,#FB,#FC,#FD,#FE,#FE,#FF,#FF
/*
224   , 320   .  ""     ,   ,     .
  : 44  , 180 - 
  : 32  , 288 - .
*/
		align 2

snow_pal	incbin "_spg/snoww.tga.pal"

splash_pal	incbin "_spg/splash-tittle-3.tga.pal"

faded_pal	ds 8*32
girl_pal	incbin "_spg/NYgirl_op.tga.pal"
font_pal	incbin "_spg/font_8x16_NY.tga.pal"
gift_pal	incbin "_spg/gifts-right.tga.pal"
ded_pal		incbin "_spg/ded-moroz.tga.pal"
logo_pal	incbin "_spg/HNY-logo_2.tga.pal"

		align 256
sin		;incbin "pic_pos_o.bin"
		incbin "_spg/sin.bin"
;		incbin "_spg/tw_sin.bin"
		; wait, , num_sprite, speed, pal, Yadder, Y,Yhigh, X
spr_anim	ds all_sprites*9
		db #ff,#ff,#ff,#ff,#ff,#ff

/*
spr_anim	dup all_sprites-2
		db 4,4,0,0,1,1,1,0,1
		edup
*/		



		ALIGN 2
spr_db		
/*
		DB 0
		DB %01000000	; leap
		DB 0
		DB %00010000
		DB 0
		DB %11100000
*/
/*		
		DB 0
		DB %01000000	; leap
		DB 0
		DB %00010000
		DB 0
		DB %11100000
*/
spr1		dup all_sprites
		db -16		;y
		db SP_SIZE32+SP_ACT
;		db %00111000
		db 0		;x
		db SP_SIZE32
;		db %00001010
		db 0
		db %00000000
		edup

		DB 0		;exit
		DB %01000000	; leap
		DB 0
		DB %00010000
		DB 0
		DB %11100000
spr_db_end
		align 256
faded_splash_db	ds 240*2+32

sinx	db 7,1,0,6,12,13,9,4,2,5,9,10,9,6,4,5,6,7,6,5,6,7,6,5,6,7,6,6,5,6,6,6,7,6,6,6,6,5,6,6,6,6,6,6,7
	dup 192-30
	db 6
	edup

text	 	include "text-2.asm"

		align 256
font_db		ds 2*96


end
	include "tsconfig.asm"
	SAVEBIN "_spg/nygift.bin",start, end-start
